/*
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code in this file as it was released upon
 * April 1, 2001 and that is NOT a joke!
 *
 * The Initial Developer of the Original Code is Henk-Johan van Rantwijk.
 * all Portions created by Henk-Johan van Rantwijk are Copyright (C) 2001-2004
 * by Henk-Johan van Rantwijk. All Rights Reserved.
 *
 * Contributor(s): 
 *
 *  HJ van Rantwijk  <bugs4hj@netscape.net> 
 *  Huijing Zhou <hj@cip.wiwi.uni-karlsruhe.de>
 *  Raj Bhaskar <r.bhaskar@compserv.gla.ac.uk>
*/

const G_VER             = "1.6.4.0";
const G_REVISION        = "b";
const G_MSG             = "MultiZilla v" + G_VER + G_REVISION;
const G_NAME            = "multiviews";

const G_NEED_BUILD      = 2003062400; // 2004041620;
const G_NEED_BUILD_4MAC = 2003062400; // 2004041620;

const G_CHROME          = "chrome";
const G_PROFILE         = "Current User"; // "Profile";

const G_DEFAULTS        = "defaults";
const G_PREFS           = "Preferences";
const G_PROGRAM         = "program";
const G_COMPONENTS      = "components";
const G_CONTENT         = "content/multiviews/";

const G_MODERN_SKIN     = "skin/modern/multiviews/";
const G_CLASSIC_SKIN    = "skin/classic/multiviews/";

const G_LOCALE             = "locale/en-US/multiviews/";
const G_JAR_FILE           = "multiviews.jar";
const G_PREF_FILE          = "all-mz.js";
const G_LOCALSTORE_FILE    = "multizilla.rdf";
const G_UPDATENOTIFIER     = "mzUpdateNotifier.js";
const G_CONTENTBLOCKER     = "mzContentBlocker.js";
const G_CONTENBLOCKER_FILE = "default-filters.rdf";
const G_USERAGENTS_FILE    = "useragents.rdf";

const G_PROGRAM_DIR    = getFolder(G_PROGRAM);
const G_COMPONENTS_DIR = getFolder(G_COMPONENTS);
const G_DEFPREF_DIR    = getFolder(G_PROGRAM, "defaults/pref");
const G_DEFPROFILE_DIR = getFolder(G_PROGRAM, "defaults/profile");
const G_PROFILE_DIR    = getFolder(G_PROFILE);
const G_COMPREG        = getFolder(G_PROGRAM, "components/compreg.dat");
const G_COMPONENTREG   = getFolder(G_PROGRAM, "component.reg");

const COMNT_1  = "Installation of " + G_MSG;
const COMNT_2  = "MultiZilla's jar file";
const COMNT_3  = "Mozilla version to old for this version of MultiZilla: Aborting Installation";
const COMNT_4  = "MultiZilla's default preference settings";
const COMNT_5  = "MultiZilla's RDF file";
const COMNT_6  = "MultiZilla's Update Notifier";
const COMNT_7  = "Warning: installing with self compiled version (BuildID = 0)";
const COMNT_8  = "MultiZilla's Content Blocker";
const COMNT_9  = "MultiZilla's Default Filters";
const COMNT_10 = "MultiZilla's User Agents";

// The MultiZilla installation process is 'multi-user based' by default
var G_CHROME_LOC = G_CHROME;
var G_CHROME_TYPE = DELAYED_CHROME;
var G_CHROME_DIR = getFolder(G_CHROME);
var installTypeMsg = "InstallType: multi-user installation";
// Check for prior installations in the users profile directory
var profileChromeDir = getFolder("Current User", G_CHROME); 
var profileJAR = getFolder(profileChromeDir, G_JAR_FILE); // getFolder(G_PROFILE, G_JAR_FILE);
var priorProfileInstall = File.exists(profileJAR);
// Check for prior installations in the program directory
var chromeJAR = getFolder(G_CHROME, G_JAR_FILE);
var priorChromeInstall = File.exists(chromeJAR);
// Initialize the prior installation flag
var priorInstallation = false;
  // Update the prior installation flag
  if (priorProfileInstall || priorChromeInstall)
    priorInstallation = true;
  // Is this a fresh installation of MultiZilla?
  if (!priorInstallation) {
    logComment("New MultiZilla installation");
    // Ask if MultiZilla should be installed in the profile directory, but only for new installations
    // Installing the same add-on, in both the profile and chrome directory, makes one big mess of it!
    if (confirm("Select OK, for a single-user installation\nor CANCEL, for a multi-user installation")) {
      installTypeMsg = "InstallType: single-user installation";
      G_CHROME_TYPE = PROFILE_CHROME; // | DELAYED_CHROME;
      G_CHROME_DIR = profileChromeDir; // getFolder(G_PROFILE);
      G_CHROME_LOC = profileChromeDir; // G_PROFILE;
    }
    else installTypeMsg = "InstallType: multi-user installation";
  }
  // We end-up here after locating a prior installation in the users profile directory
  // No need for a confirmation, just install MultiZilla in the profile directory
  else if (priorProfileInstall) {
    installTypeMsg = "InstallType: single-user installation";
    G_CHROME_TYPE = PROFILE_CHROME; // | DELAYED_CHROME;
    G_CHROME_DIR = profileChromeDir; // getFolder(G_PROFILE);
    G_CHROME_LOC = profileChromeDir; // G_PROFILE;
  }
  var err = initInstall(G_MSG, G_NAME, G_VER);
  var platformStr;
  var platformNode;
  var abort = false;

  logComment(COMNT_1 + " in directory: " + G_CHROME_DIR);
  logComment("initInstall: " + err);
  // Write "InstallType: xxxxx-user installation" in the logfile
  logComment(installTypeMsg);

  if (!err)
    err = "Ok";
  logComment("Installation init : " + err);
  // select used platform
  if ('platform' in Install) {
    platformStr = new String(Install.platform);

    if (!platformStr.search(/.*Darwin/))
      platformNode = 'unix';
    if (!platformStr.search(/^Macintosh/))
      platformNode = 'mac';
    else if (!platformStr.search(/^Win/))
      platformNode = 'win';
    else if (!platformStr.search(/^OS\/2/))
      platformNode = 'win';
    else
      platformNode = 'unix';
  }
  else {
    var fOSMac = getFolder("Mac System");
    var fOSWin = getFolder("Win System");

    logComment("fOSMac: "  + fOSMac);
    logComment("fOSWin: "  + fOSWin);

    if (fOSMac != null)
      platformNode = 'mac';
    else if (fOSWin != null)
      platformNode = 'win';
    else
      platformNode = 'unix';
  }
  // install only if we have a compatible version of Mozilla
  if (platformNode == 'mac' && buildID < G_NEED_BUILD_4MAC) {
    G_NEED_BUILD = G_NEED_BUILD_4MAC
    abort = true;
  }
  else if (buildID < G_NEED_BUILD) // Windows/Unix/Linux
    abort = true;

  if (abort) {
    if (buildID > 0) {
      alert("Aborting this " + COMNT_1 + 
            "\n\nYou need Mozilla {Build ID: " + G_NEED_BUILD + "} for this installation\n" +
            "but you are using Mozilla {Build ID:" + buildID + "} instead.\n" + 
            "Visit www.mozilla.org and install a recent mozilla build!");
      logComment(COMNT_3);
      cancelInstall();
    }
    else { // No BuildID, compiled without env. variable set!
      alert("Warning: BuildID = 0\n" + 
            "This installation might fail befause of this!\n" + 
            "Please read the instructions on this page:\n\n" + 
            "http://www.mozilla.org/build/distribution.html");
      logComment(COMNT_7);
      abort = false; // allow installation anyway
    }
  }
  if (!abort) {
    ///////////////////////////////////////////////////////////////
    // MultiZilla's 'Update Notifications' needs to be registered
    // and this doesn't seem to work for older mozilla builds.
    // We just wack the registry, to make sure it gets registered!
    ///////////////////////////////////////////////////////////////
    if (File.exists(G_COMPREG))
      File.remove(G_COMPREG);
    else if (File.exists(G_COMPONENTREG))
      File.remove(G_COMPONENTREG);

    addFile(COMNT_2, G_JAR_FILE, G_CHROME_DIR, "");
    addFile(COMNT_4, G_PREF_FILE, G_DEFPREF_DIR, "");
    addFile(COMNT_6, G_UPDATENOTIFIER, G_COMPONENTS_DIR, "");
    addFile(COMNT_8, G_CONTENTBLOCKER, G_COMPONENTS_DIR, "");
    ///////////////////////////////////////////////////////////////
    // Copy multizilla.rdf for new MultiZilla installation only!
    ///////////////////////////////////////////////////////////////
    if (!File.exists(getFolder(G_PROFILE, G_LOCALSTORE_FILE)))
      addFile(COMNT_5, G_LOCALSTORE_FILE, G_PROFILE_DIR, "")
    addFile(COMNT_5, G_LOCALSTORE_FILE, G_DEFPROFILE_DIR, "");
    addFile(COMNT_9, G_CONTENBLOCKER_FILE, G_PROFILE_DIR, "");
    ///////////////////////////////////////////////////////////////
    // Copy useragents.rdf for new MultiZilla installation only!
    ///////////////////////////////////////////////////////////////
    if (!File.exists(getFolder(G_PROFILE, G_USERAGENTS_FILE)))
      addFile(COMNT_10, G_USERAGENTS_FILE, G_PROFILE_DIR, "");

    if (platformNode == "win")
      logComment("Installation started for Win32 platform");
    else 
      logComment("Installation started for a *nix/Mac platform");

	registerChrome(CONTENT | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_JAR_FILE), G_CONTENT);
    registerChrome(SKIN    | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_JAR_FILE), G_MODERN_SKIN);
    registerChrome(SKIN    | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_JAR_FILE), G_CLASSIC_SKIN);
    registerChrome(LOCALE  | G_CHROME_TYPE, getFolder(G_CHROME_LOC, G_JAR_FILE), G_LOCALE);

    err = getLastError();

    if (err == SUCCESS)
      err = performInstall();
    else {
      if (err == ACCESS_DENIED) {
        var access = "The user did not grant the required security privilege.";
        logComment(access);
      }
      logComment("Detailed information can be found at: http://multizilla.mozdev.org/xpi/return-codes.html#ret-202");
      cancelInstall(err);
    }
    err = getLastError();
    if (err == SUCCESS || err == REBOOT_NEEDED) {
      var msg = G_MSG + " has been installed successfully: " + err;
      var finish = (err == SUCCESS) ? "\nPlease restart your browser (including QuickLaunch) to continue." :
                                      "\nYou might need to reboot, restart your browser (including QuickLaunch) to continue.";
      refreshPlugins();
      alert(msg+finish);
    }
  }
